function buildNavBar(root) {
    var res = '';
    $(root).children("section").each(function (idx,elt) {
        elt = $(elt);
        var title;
        if (elt.attr("data-title")) {
            title = elt.attr("data-title");
        } else {
            title = $(elt.children("h2, h3, h4, h5, h6")[0]).text();
        }
        var link="#"+elt.attr("id");
        var html;
        var subsections = elt.children("section");
        var hasSubsections = subsections.length > 0;
        if (hasSubsections) {
            html = '<li class="dropdown"><a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">'+title+' <span class="caret"></span></a><ul class="dropdown-menu">';
            html += buildNavBar(elt);
            html += '</ul>';
        } else {
            html = '<li><a href="'+link+'">'+title+'</a></li>';
        }
        res += html;
    });
    return res;
}

function buildTOC(root) {
    var res = '<ul>';
    $(root).children("section").each(function (idx,elt) {
        elt = $(elt);
        var title;
        if (elt.attr("data-title")) {
            title = elt.attr("data-title");
        } else {
            title = $(elt.children("h2, h3, h4, h5, h6")[0]).text();
        }
        var link="#"+elt.attr("id");
        var html;
        var subsections = elt.children("section");
        var hasSubsections = subsections.length > 0;
        if (hasSubsections) {
            html = '<li>'+title;
            html += buildTOC(elt);
        } else {
            html = '<li><a href="'+link+'">'+title+'</a></li>';
        }
        res += html;
    });
    res += '</ul>';
    return res;
}

function setupAbstractButtons() {
    $("span.abstract-button").each(function(idx,elt) {
        var absId = $(elt).attr("data-absid");
        var abs = $("#"+absId);
        var visible = false;
        $(elt).click(function(evt){
            visible = !visible;
            abs.toggle(visible);
            $(elt).text(visible?"hide":"show");
        });
    });
}

function setupPage() {
    console.log("ready");
    var menusToAdd = buildNavBar($("#main-content"));
    $("#navbar>ul").append(menusToAdd);
    $("#toc").append(buildTOC($("#main-content")));
    console.log("menu done");
    setupAbstractButtons();
    console.log("abstracts done");
}

$(document).ready(setupPage);











